var expense_item_obj = null ;

$(document).ready(function() 
{ 
	$('#formExpenseItem').hide() ;
	$('#btnExpenseItemClear').button().bind('click',clearExpenseItem) ;
	$('#btnExpenseItemUpdate').button().bind('click',updateExpenseItem) ;
	$('#btnExpenseItemAdd').button().bind('click',addExpenseItem) ;
	$('#btnExpenseItemPrint').button().bind('click',printExpenseItem) ;
	// $('#expense-item-tabs').tabs() ;
	$('#txtExpenseItemDesc').focus() ;
	$(window).resize(resizeExpenseItemGrid) ;
	resizeExpenseItemGrid() ;
	clearExpenseItem();
	filterExpenseItem();
}) ;

function showFormExpenseItem(){
	clearExpenseItem();
	$('#formExpenseItem').show('slow') ;
}

function closeFormExpenseItem(){
	clearExpenseItem() ;
	$('#formExpenseItem').hide('slow') ;
}

function resizeExpenseItemGrid() {
	var h = $("#sbg-center-panel").outerHeight() - $("#sbg-expense-item-entry").outerHeight() - 55;
	$("div#sbg-expense-item-data").css("height", h +'px') ;		
}

function clearExpenseItem() {
	$('#txtExpenseItemId').val("Auto") ;
	$('#txtExpenseItemDesc').val("") ;
	$('#txtExpenseItemCode').val("") ;
	// $('#expense-item-tabs').tabs("option", "active", 0) ;
	$('#txtExpenseItemDesc').focus() ;
	$('#btnExpenseItemUpdate').prop('disabled','disabled') ;
	$('#expense_item_err_mesg').text('') ;
	$('#expense_item_err_desc').hide() ;
	$('#expense_item_err_code').hide() ;
	if (expense_item_obj != null && expense_item_obj != undefined)
	{
		$($(expense_item_obj).closest("tr")).removeClass("sbg-row-selected") ;
	}
	expense_item_obj = null;
}

function filterExpenseItem() {
	var data = { "type": C_LIST} ;
	var url = "request.pzx?c=" + expense_item_url + "&d=" + new Date().getTime() ;		
	callServer(url,"json",data,showExpenseItemFilterList,expense_item_obj) ;
}

function showExpenseItemFilterList (obj,resp) {
	dataJSONArray = resp;
	$('.sbg-expense-item-table').KTDatatable('destroy');
	init_dt();
}

function init_dt() {
	var datatable = $('.sbg-expense-item-table').KTDatatable({
		// datasource definition
		data: {
			type: 'local',
			source: dataJSONArray,
			pageSize: 5, // display 20 records per page
			serverPaging: true,
			serverFiltering: true,
			serverSorting: true,
		},

		// layout definition
		layout: {
			scroll: true, // enable/disable datatable scroll both horizontal and vertical when needed.
			height: 'auto', // datatable's body's fixed height
			footer: false, // display/hide footer
		},

		// column sorting
		sortable: true,

		// toolbar
		toolbar: {
			// toolbar placement can be at top or bottom or both top and bottom repeated
			placement: ['bottom'],

			// toolbar items
			items: {
				// pagination
				pagination: {
					// page size select
					pageSizeSelect: [5, 10, 20, 30, 50], // display dropdown to select pagination size. -1 is used for "ALl" option
				},
			},
		},

		search: {
			input: $('#generalSearch'),
		},

		columns: [
			{
				field: "id",
				title: "ID",
				width:30,
			}, {
				field: "code",
				title: "Code",
				width:70,
			}, {
				field: "desc",
				title: "Description",
				width:200,
			}, {
				field: 'actions',
				title: 'Actions',
				sortable: true,
				width: 470,
				overflow: 'visible',
		}],
	});
}

function updateExpenseItem() {
	saveExpenseItem(C_UPDATE) ;
}
function addExpenseItem() {
	saveExpenseItem(C_ADD) ;
}
function saveExpenseItem(type) {
	if (!validateExpenseItem()) {
		return false;
	}
	var data = { "type": type, 
                    "id": $('#txtExpenseItemId').val(), 
                    "desc": $('#txtExpenseItemDesc').val(), 
                    "code": $('#txtExpenseItemCode').val()};
	var url = "request.pzx?c=" + expense_item_url + "&d=" + new Date().getTime() ;
	callServer(url,"json",data,onExpenseItemResponse,expense_item_obj) ;
}

function editExpenseItem(id,obj) {
	var data = { "type": C_GET,"id": id} ;
	var url = "request.pzx?c=" + expense_item_url + "&d=" + new Date().getTime();		
	clearExpenseItem();
	showFormExpenseItem();
	expense_item_obj = obj ;
	$($(obj).closest("tr")).addClass("sbg-row-selected");
	callServer(url,"json",data,showExpenseItem,obj) ;
}

function deleteExpenseItem(id,obj) {
	// if (confirm("Confirm you want to delete Expense Item id : " + id + "?") == false) {
	// 	return false;
	// }
	
	// var data = {"type": C_DELETE,"id": id} ;
	// var url = "request.pzx?c=" + expense_item_url + "&d=" + new Date().getTime() ;
	// callServer(url,"json",data,onExpenseItemResponse,obj) ;

	//======================================================

	swal("Confirm you want to delete Expense Item id : " + id + "?", {
		buttons: {
			ok: true,
		  cancel: "Cancel",
		},
	  })
	  .then((value) => {
		switch (value) {
		  case "ok":
			  var data = {"type": C_DELETE,"id": id} ;
			  var url = "request.pzx?c=" + expense_item_url + "&d=" + new Date().getTime() ;
			  callServer(url,"json",data,onExpenseItemResponse,obj) ;
		  break;
		}
	  });
}
function showExpenseItem(obj,resp) {
	if (resp.status != C_OK) {
		swal("System Message",resp.mesg) ;
		return false;
	}
	
	$('#txtExpenseItemId').val(resp.data.id) ;
	$('#txtExpenseItemDesc').val(resp.data.desc) ;
	$('#txtExpenseItemCode').val(resp.data.code) ;
	$('#btnExpenseItemUpdate').prop('disabled','') ;
	$('#txtExpenseItemDesc').focus() ;
}
function printExpenseItem() {
	var url = "report.pzx?c=" + expense_item_url + "&d=" + new Date().getTime();
	showReport(url) ;
}
function onExpenseItemResponse(obj,resp) {
	if (resp.status != C_OK) {
		swal("Error",resp.mesg) ;
		return;
	}
	if (resp.type == C_ADD) {
		swal("Successfull!", "Your Item Successfully add to the system", "success"); 
	} else if (resp.type == C_DELETE) {
		swal("Successfull!", "Your Item Successfully delete to the system", "success");
	} else if (resp.type == C_UPDATE) {
		swal("Successfull!", "Your Item Successfully update to the system", "success");
	}
	$('#sbg-popup-box').html(resp.mesg) ;
	$('#sbg-popup-box').show() ;
	$('#sbg-popup-box').fadeOut(5000) ;
	clearExpenseItem() ;
	filterExpenseItem();
	closeFormExpenseItem();
}
function validateExpenseItem() {
	$('#expense_item_err_mesg').text('') ;
	if ($('#txtExpenseItemDesc').val()=="")
	{
		$('#expense_item_err_desc').show() ;
		$('#txtExpenseItemDesc').focus() ;
		swal("Expense Item description can not be blank.") ;
		return false ;
	}
	else 
		$('#expense_item_err_desc').hide() ;
    
	if ($('#txtExpenseItemCode').val()=="")
	{
		$('#expense_item_err_code').show() ;
		$('#txtExpenseItemCode').focus() ;
		swal("Expense Item code can not be blank.") ;
		return false ;
	}
	else 
		$('#expense_item_err_code').hide() ;
			
	return true ;
}